<div class="spells-list">

    {{#each system.memorizations as |slotData spellType|}}
        <div class="general-header ars_clps{{#if (getViewState @root.actor.id (concat 'spells-' (toLowerCase spellType))) }} ars_clps_on{{/if}}"
            data-vs-control="spells-{{spellType}}">
            {{ localize "ARS.spells" }} - {{localize (concat "ARS.spellTypes." spellType)}}
            <a class="sync-owned-spells" data-tooltip="Synchronize owned spells with source versions">
                <i class="fas fa-recycle"></i></a>
        </div>
        <div class="item-list combat-memorization-block ars_clps_container" style="margin-bottom: 3px;">
            <div class="memorization-slot general-subheader flexrow">
                <div style="flex-grow:2;" class="flexrow">
                    <div style="flex: 0 0 24px;margin-right: 5px;"></div>
                    <div class="actor-name">Name</div>
                </div>
                <div class="short-spell-field text-trunc">{{localize "ARS.level"}}</div>
                <div class="short-spell-field text-trunc">{{localize "ARS.status"}}</div>
                <div class="short-spell-field text-trunc" data-tooltip="{{localize "ARS.components"}}">
                    {{localize "ARS.componentsAbbr"}}
                </div>
                <div class="short-spell-field text-trunc" data-tooltip="{{localize "ARS.casttime"}}">
                    {{localize "ARS.casttimeAbbr"}}
                </div>
                <div class="long-spell-field">{{localize "ARS.range"}}</div>
                <div class="">{{localize "ARS.aoe"}}</div>
                <div class="memorization-controls"></div>
            </div>
            {{#each slotData.spellslots.value as |slotCount level| }}
                {{!-- {{log "memorization-block.hbs slotCount" slotCount}} --}}
                {{#if slotCount}}
                    <li class="memslot-collapse memslotlevel.{{level}} ars_clps{{#if (getViewState @root.actor.id (concat  (concat 'spellsbylevel-' (toLowerCase spellType) level))) }} ars_clps_on{{/if}}"
                        data-vs-control="spellsbylevel-{{spellType}}{{level}}" data-type="{{spellType}}"
                        data-level="{{level}}">
                        {{ localize "ARS.spell" }} {{localize "ARS.level"}}
                        {{level}}
                        </a>
                    </li>
                    <div class="ars_clps_container">
                        {{#each (lookup slotData.memslots level) as | memslot slotindex|}}
                            <li class="memorization-slot item reveal-hidden flexrow{{#if memslot.cast}} memorization-used{{/if}} info-item"
                                data-control-type="memorization" data-id="{{memslot.id}}" data-uuid="{{memslot.uuid}}"
                                data-level="{{level}}" data-index="{{slotindex}}" data-type="{{spellType}}"
                                data-owned="{{memslot.owned}}">
                                {{#if memslot.id}}
                                    <div class="item-name rollable flexrow spellCard-roll" data-id="{{memslot.id}}">
                                        {{#if (and @root.actor.needsInitiative @root.game.ars.config.settings.initiativeUseSpeed)}}
                                            {{#if @root.actor.combat.flags.ars.beginningOfRound}}
                                                <div class="initiative-roll-speed" data-tooltip="Roll initiative"
                                                    role="button" aria-label="Roll initiative">
                                                    <i class="fas fa-dice"></i>
                                                </div>
                                            {{/if}}
                                        {{/if}}

                                        <div class="item-image" aria-label="{{memslot.name}}"
                                            style="background-image: url('{{memslot.img}}')"></div>
                                        <div class="item-name text-trunc">{{memslot.name}}</div>
                                    </div>


                                    <div class="short-spell-field text-trunc">{{memslot.level}}</div>
                                    <div class="short-spell-field text-trunc">
                                        {{#if memslot.cast}}Used{{else}}Ready{{/if}}
                                    </div>
                                    <div class="short-spell-field text-trunc">
                                        {{#if memslot.spellItem.system.components.verbal}}V{{/if}}{{#if memslot.spellItem.system.components.somatic}}S{{/if}}{{#if memslot.spellItem.system.components.material}}M{{/if}}
                                    </div>
                                    <div class="short-spell-field text-trunc"
                                        data-tooltip="{{memslot.spellItem.system.castingTime}}">
                                        {{memslot.spellItem.system.castingTime}}
                                    </div>
                                    <div class="long-spell-field text-trunc"
                                        data-tooltip="{{memslot.spellItem.system.range}}">
                                        {{memslot.spellItem.system.range}}
                                    </div>
                                    <div class="text-trunc" data-tooltip="{{memslot.spellItem.system.areaOfEffect}}">
                                        {{memslot.spellItem.system.areaOfEffect}}
                                    </div>
                                    <div class="memorization-controls">
                                        {{#if memslot.owned}}
                                            <a class="item-control hidden item-edit" data-tooltip="Edit Item"><i
                                                    class="fas fa-edit"></i></a>
                                        {{else}}
                                            <a class="item-control hidden item-view" data-tooltip="View Item"><i
                                                    class="fas fa-edit"></i></a>
                                        {{/if}}
                                        <a class="memorization-controls memslot-remove" data-action="remove"
                                            data-tooltip="{{ localize "ARS.clearslot" }}"><i
                                                class="fas fa-eraser"></i></a>
                                        <a class="memorization-controls memslot-toggle" data-action="toggle"
                                            data-tooltip="{{ localize "ARS.resetusage" }}"><i
                                                class="fas fa-recycle"></i></a>
                                    </div>
                                {{else}}
                                    <div class="memorization-slot-empty">
                                        {{!-- DROP SPELL OR SELECT --}}
                                        <select class="memspell-select">
                                            {{!-- {{#select newSpellID}}
                                                <option value="">{{localize "ARS.empty"}}
                                                    {{localize "ARS.level"}} {{level}}
                                                    {{localize (concat "ARS.spellTypes." spellType)}} Slot
                                                </option>
                                                {{#if (eq spellType 'arcane')}}
                                                    <optgroup label={{localize "ARS.available"}}>
                                                        {{#each (lookup (lookup @root.actor.spellsByLevel spellType) level) as |entry id|}}
                                                            {{#if entry.isLearned}}
                                                                <option value="{{id}}">
                                                                    {{entry.spellInfo}}{{#if entry.isOwned}}{{#if @root.isGM}}({{localize "ARS.owned"}}){{/if}}{{/if}}
                                                                </option>
                                                            {{/if}}
                                                        {{/each}}
                                                    </optgroup>
                                                    <optgroup label={{localize "ARS.notlearned"}}>
                                                        {{#each (lookup (lookup @root.actor.spellsByLevel spellType) level) as |entry id|}}
                                                            {{#if entry.isLearned}}
                                                            {{else}}
                                                                <option value="{{id}}">
                                                                    {{entry.spellInfo}}{{#if entry.isOwned}}{{#if @root.isGM}}({{localize "ARS.owned"}}){{/if}}{{/if}}
                                                                </option>
                                                            {{/if}}
                                                        {{/each}}
                                                    </optgroup>
                                                {{else}}
                                                    <optgroup label={{localize "ARS.owned"}}>
                                                        {{#each (lookup (lookup @root.actor.spellsByLevel spellType) level) as |entry id|}}
                                                            {{#if entry.isOwned}}
                                                                <option value="{{id}}">
                                                                    {{entry.spellInfo}}
                                                                </option>
                                                            {{/if}}
                                                        {{/each}}
                                                    </optgroup>
                                                    <optgroup label={{localize "ARS.available"}}>
                                                        {{#each (lookup (lookup @root.actor.spellsByLevel spellType) level) as |entry id|}}
                                                            {{#if entry.isOwned}}
                                                            {{else}}
                                                                <option value="{{id}}">
                                                                    {{entry.spellInfo}}
                                                                </option>
                                                            {{/if}}
                                                        {{/each}}
                                                    </optgroup>
                                                {{/if}}
                                            {{/select}} --}}

                                            {{selectSpellOptions @root.actor.spellsByLevel spellType level}}
                                        </select>
                                    </div>
                                {{/if}}
                            </li>
                        {{/each}}
                    </div>
                {{/if}}
            {{/each}}
        </div>
    {{/each}}
</div>